Index: src/backend/access/transam/xlog.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/access/transam/xlog.c,v
retrieving revision 1.341
diff -c -r1.341 xlog.c
*** src/backend/access/transam/xlog.c	28 May 2009 11:02:16 -0000	1.341
--- src/backend/access/transam/xlog.c	2 Jun 2009 02:31:34 -0000
***************
*** 3006,3011 ****
--- 3006,3012 ----
  	struct dirent *xlde;
  	char		lastoff[MAXFNAMELEN];
  	char		path[MAXPGPATH];
+ 	struct stat stat_buf;
  
  	/*
  	 * Initialize info about where to try to recycle to.  We allow recycling
***************
*** 3047,3054 ****
  				/*
  				 * Before deleting the file, see if it can be recycled as a
  				 * future log segment.
  				 */
! 				if (InstallXLogFileSegment(&endlogId, &endlogSeg, path,
  										   true, &max_advance,
  										   true))
  				{
--- 3048,3060 ----
  				/*
  				 * Before deleting the file, see if it can be recycled as a
  				 * future log segment.
+ 				 * If it's a symlink, we don't recycle it.
  				 */
! 				if (
! #if HAVE_WORKING_LINK
! 					lstat(path, &stat_buf) == 0 && !S_ISLNK(stat_buf.st_mode) &&
! #endif
! 					InstallXLogFileSegment(&endlogId, &endlogSeg, path,
  										   true, &max_advance,
  										   true))
  				{
